-- "VLC-anime.lua" -- VLC Extension script
--=============================================================
--        アニメ素材切り出し用VLC拡張　「Vlc-anime v0.1」
--            written by maimai22015(ytpmv.info)  20200512
--=============================================================

function descriptor()
	return {
		title = "VLC-anime",
		version = "0.1",
		author = "maimai22015",
		url = "ytpmv.info",
		description = [[
Cut video file with watching .
参考にしたやつ:https://addons.videolan.org/p/1154013/
]],
		capabilities = {"menu"},
	}
end

function activate()
    Create_dialog()
    Load_Conf()
    Bat_List={}
end

function deactivate()
end


function meta_changed()
end

function menu()
	return {"Show dialog"}
end


function close()
	-- vlc.deactivate()
	d:hide()
end

function trigger_menu(id)
	if id==1 then
		d:show()
	end
end



function Create_dialog()
	mydir=""
	if not vlc.misc then
		mydir = vlc.config.userdatadir()
	else
		mydir = vlc.misc.userdatadir()
    end

	d = vlc.dialog(descriptor().title)


	d:add_button("&Cut", Click_Cut, 1,1,1,1)
	d:add_button("&Generate .bat", Click_Run, 2,1,1,1)

	d:add_button("&Pause ||> &Play", function() vlc.playlist.pause() end, 3,1,1,1)
end

function Load_Conf()
    index=0
    my_conf={}
    Conf_Path=mydir.."\\lua\\extensions\\vlc-anime.ini"
    f = io.open(Conf_Path,"r")
    for line in f:lines() do
        if index % 2 ==1 then
            my_conf[#my_conf+1]=line
        end
        index =index+1
    end
    vlc.msg.info(my_conf[1])
end

function Click_Run()
    destination=folder.."\\vlc-anime-"..os.time()..".bat"
    if #Bat_List ~=0 then
    file = io.open(destination,"w")
    for i = 1, #Bat_List do
        local s = Bat_List[ i ]
	    file:write(s.."\n")
    end
    file:close()
    Bat_List={}
end

end


function Click_Cut()
    local input=vlc.object.input()
    if input then time =Time2stringDelta(vlc.var.get(input,"time"),tonumber(my_conf[2])) end
    local Hinagata1 =my_conf[1].." -ss "..time.." -t "..my_conf[3].." -i \""
    local Hinagata2="\" -map_metadata -1 -map_chapters -1 -vcodec libx264  -preset medium -tune animation \""
    local Hinagata3="\" -codec:a libfdk_aac -y "
    local item = vlc.input.item()
    local uri = item:uri()
    local uri = string.gsub(uri, '^file:///', '')
    uri = string.gsub(uri, '/', '\\')
    uri=vlc.strings.decode_uri(uri)
    local a = {}
    for w in string.gmatch(uri, "[^\\]+") do
       table.insert(a, w);
    end
    local b = {}
    for w in string.gmatch(a[#a], "[^.]+") do
       table.insert(b, w);
    end
    folder = string.match(uri, "^(.+)\\")
    time = string.gsub(time,":","-")
    local bat = Hinagata1..uri..Hinagata2..my_conf[4]..b[1].."_"..time.."."..b[#b]..Hinagata3
    table.insert(Bat_List, bat)  
    vlc.msg.info(bat)
end

--TODO　キーボード操作


function Time2stringDelta(timestamp,delta)
    timestamp=timestamp/1000000-- VLC 3 microseconds fix
    if timestamp + delta >0 then
        timestamp =timestamp + delta
    end
	return string.format("%02d:%02d:%06.3f", math.floor(timestamp/3600), math.floor(timestamp/60)%60, timestamp%60):gsub("%.",".")
end

